Attribute VB_Name = "DNAExecution"
Option Explicit

'boolstack structure used for conditionals
Private Type boolstack
  val(20) As Boolean
  pos As Integer
End Type

Type block
  tipo As Integer
  value As Integer
End Type

Dim CurrentFlow As Byte
Const CLEAR As Byte = 0
Const COND As Byte = 1
Const BODY As Byte = 2
Const ELSEBODY As Byte = 3

Dim CurrentCondFlag As Boolean
Const NEXTBODY As Boolean = True 'both of these two are subsets of the clear flag technically
Const NEXTELSE As Boolean = False

Public sysvar(1000) As var    ' array of system variables
Public Const stacklim As Integer = 20

' stack structure, used for robots' stack
Private Type Stack
  val(stacklim) As Long
  pos As Integer
End Type

Private Type Queue
  Memloc As Integer
  Memval As Integer
End Type

Public IntStack As Stack
Public Condst As boolstack 'for the conditions stack
Dim CommandQueue() As Queue 'apply stores at end of cycle

Dim currbot As Long
Dim currgene As Long 'for *.thisgene

''''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''

Private Sub ExecuteDNA(n As Integer)
  Dim A As Integer
  Dim tipo As Long
  
  currbot = n
  currgene = 0
  CurrentCondFlag = NEXTBODY 'execute body statements if no cond is found
  
  With rob(n)
  A = 1
  While Not (.DNA(A).tipo = 10 And .DNA(A).value = 1)
    tipo = .DNA(A).tipo
    Select Case tipo
      Case 0 'number
        If CurrentFlow <> CLEAR Then
          PushIntStack .DNA(A).value
        End If
      Case 1 '*number
        If CurrentFlow <> CLEAR And .DNA(A).value <= 1000 And .DNA(A).value > 0 Then
          PushIntStack .mem(.DNA(A).value)
        End If
      Case 2 'commands (add, sub, etc.)
        If CurrentFlow <> CLEAR Then
          ExecuteBasicCommand .DNA(A).value
        End If
      Case 3 'advanced commands
        If CurrentFlow <> CLEAR Then
          ExecuteAdvancedCommand .DNA(A).value
        End If
      Case 4 'bitwise commands
        If CurrentFlow <> CLEAR Then
          ExecuteBitwiseCommand .DNA(A).value
        End If
      Case 5 'conditions
        If CurrentFlow = COND Then
          ExecuteConditions .DNA(A).value
        End If
      Case 6 'logic commands (and, or, etc.)
        If CurrentFlow = COND Then
          ExecuteLogic .DNA(A).value
        End If
      Case 7 'store, inc and dec
        If CurrentFlow = BODY Then
          ExecuteStores .DNA(A).value
        End If
      Case 8 'reserved for a future type
      Case 9 'flow commands
        ExecuteFlowCommands (.DNA(A).value)
        
        'If .VirusArray(currgene) > 1 Then 'next gene is busy, so clear flag
        '  CurrentFlow = CLEAR
        'End If
        
        .mem(thisgene) = currgene
      Case 10 'Master flow, such as end, chromostart, etc.
        'ExecuteMasterFlow .dna(a).value
    End Select
    A = A + 1
  Wend
  End With
End Sub

''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''

Private Sub ExecuteBasicCommand(n As Integer)
  '& denotes commands that can be constructed from other commands, but
  'are still basic enough to be listed here
  
  Select Case n
    Case 1 'add
      DNAadd
    Case 2 'sub (negative add) &
      DNASub
    Case 3 'mult
      DNAmult
    Case 4 'div
      DNAdiv
    Case 5 'rnd
      DNArnd
    Case 6 'dereference AKA *
      DNAderef
    Case 7 'mod
      DNAmod
    Case 8  'sgn
      DNAsgn
    Case 9 'absolute value &
      DNAabs
    Case 10 'dup
      DNAdup
  End Select
End Sub

Private Sub DNAadd()
  Dim A As Single
  Dim b As Single
  Dim c As Double
  b = PopIntStack
  A = PopIntStack
  
  A = A Mod 2000000000
  b = b Mod 2000000000
  
  c = A + b
  
  If Abs(c) > 2000000000 Then c = c - Sgn(c) * 2000000000
  PushIntStack c
End Sub

Private Sub DNASub()
  Dim A As Long
  Dim b As Long
  Dim c As Single
  b = PopIntStack
  A = PopIntStack
  c = A - b
  c = c Mod 2000000000#
  PushIntStack c
End Sub

Private Sub DNAmult()
  Dim A As Single
  Dim b As Single
  Dim c As Single
  b = PopIntStack
  A = PopIntStack
  c = A * b
  If Abs(c) > 2000000000 Then c = Sgn(c) * 2000000000
  PushIntStack c
End Sub

Private Sub DNAdiv()
  Dim A As Long
  Dim b As Long
  b = PopIntStack
  A = PopIntStack
  If b <> 0 Then
    PushIntStack A / b
  Else
    PushIntStack 0
  End If
End Sub

Private Sub DNArnd()
  PushIntStack Random(0, PopIntStack)
End Sub

Private Sub DNAderef()
  Dim b As Long
  
  b = PopIntStack
  
  If b <= 1000 And b >= 1 Then
    PushIntStack rob(currbot).mem(b)
  Else
    PushIntStack 0
  End If
End Sub

Private Sub DNAmod()
  Dim b As Long
  
  b = PopIntStack
  If b = 0 Then
    PopIntStack
    PushIntStack 0
  Else
    PushIntStack PopIntStack Mod b
  End If
End Sub

Private Sub DNAsgn()
  PushIntStack Sgn(PopIntStack)
End Sub

Private Sub DNAabs()
  PushIntStack Abs(PopIntStack)
End Sub

Private Sub DNAdup()
  Dim b As Long
  
  b = PopIntStack
  PushIntStack b
  PushIntStack b
End Sub

'''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''''

Private Sub ExecuteAdvancedCommand(n As Integer)
  Select Case n
    Case 1 'findang
      findang
    Case 2 'finddist
      finddist
    Case 3 'ceil
      DNAceil
    Case 4 'floor
      DNAfloor
    Case 5 ' sqr
      DNASqr
    Case 6 ' power
      DNApow
    Case 7 ' pyth
      DNApyth
  End Select
End Sub

Private Sub findang()
  Dim A As Long  'target xpos
  Dim b As Long  'target ypos
  Dim c As Long  'robot's xpos
  Dim d As Long  'robot's ypos
  Dim e As Single  'angle to target
  b = PopIntStack
  A = PopIntStack
  c = rob(currbot).pos.x
  d = rob(currbot).pos.y
  e = angnorm(angle(c, d, A, b)) * 200
  PushIntStack e
End Sub

Private Sub finddist()
  Dim A As Single  'target xpos
  Dim b As Single  'target ypos
  Dim c As Single  'robot's xpos
  Dim d As Single  'robot's ypos
  Dim e As Single  'distance to target
  b = PopIntStack
  A = PopIntStack
  c = rob(currbot).pos.x
  d = rob(currbot).pos.y
  e = Sqr(((c - A) ^ 2 + (d - b) ^ 2))
  If Abs(e) > 2000000000# Then
    e = Sgn(e) * 2000000000#
  End If
  PushIntStack CLng(e)
End Sub

'applies a ceiling to a value on the stack.
'Usage: val ceilingvalue ceil.
Private Sub DNAceil()
  Dim A As Long
  Dim b As Long

  b = PopIntStack
  A = PopIntStack

  PushIntStack IIf(A > b, b, A)
End Sub

'similar to ceil but with a floor instead
Private Sub DNAfloor()
  Dim A As Long
  Dim b As Long

  b = PopIntStack
  A = PopIntStack

  PushIntStack IIf(A < b, b, A)
End Sub

'Returns square root of a positive number. Can't think of a specific use but it is valid.
Private Sub DNASqr()
    Dim A As Single
    A = PopIntStack
    Dim b As Long
    
    If A > 0 Then
      b = Sqr(A)
    Else
      b = 0
    End If
    
    PushIntStack b
End Sub

'returns a power number. Raises a (top number) to the power of b (second number)
'Seems kind of pointless to me
Private Sub DNApow()
    Dim A As Double
    Dim b As Double
    Dim c As Double
    b = PopIntStack
    A = PopIntStack
    
    If Abs(b) > 10 Then b = 10 * Sgn(b)
    
    Dim index As Long
    
    If A = 0 Then
      c = 0
    Else
      c = A ^ b
    End If
    If Abs(c) > 2000000000 Then c = Sgn(c) * 2000000000
    PushIntStack c
End Sub

Private Sub DNApyth()
  Dim A As Single
  Dim b As Single
  
  b = PopIntStack
  A = PopIntStack
  Dim c As Single
  
  c = Sqr(A * A + b * b)
  If Abs(c) > 2000000000 Then c = Sgn(c) * 2000000000
  
  PushIntStack c
End Sub

'''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''

'unimplemented as yet
Private Sub ExecuteBitwiseCommand(n As Integer)
  Select Case n
    Case 1 'Compliment ~ (tilde)
      DNABitwiseCompliment
    Case 2 '& And
      DNABitwiseAND
    Case 3 '| or
      DNABitwiseOR
    Case 4 ' XOR, ^ (I need another representation)
      DNABitwiseXOR
    Case 5 'bitinc ++
      DNABitwiseINC
    Case 6 'bitdec --
      DNABitwiseDEC
    Case 7 'negate
      PushIntStack -PopIntStack
    Case 8 ' <<
      DNABitwiseShiftLeft
    Case 9 ' >>
      DNABitwiseShiftRight
  End Select
End Sub

Private Sub DNABitwiseCompliment()
  Dim value As Long
  Dim bits As DoubleWord
  
  value = PopIntStack
  bits = NumberToBit(value)
  InvertBits bits
  PushIntStack BitToNumber(bits)
End Sub

Private Sub DNABitwiseAND()
  Dim valueA As Long
  Dim valueB As Long
  Dim bitsA As DoubleWord
  Dim bitsB As DoubleWord
  
  valueB = PopIntStack
  valueA = PopIntStack
  
  bitsA = NumberToBit(valueA)
  bitsB = NumberToBit(valueB)
  
  bitsA = BitAND(bitsA, bitsB)
  PushIntStack BitToNumber(bitsA)
End Sub

Private Sub DNABitwiseOR()
  Dim valueA As Long
  Dim valueB As Long
  Dim bitsA As DoubleWord
  Dim bitsB As DoubleWord
  
  valueB = PopIntStack
  valueA = PopIntStack
  
  bitsA = NumberToBit(valueA)
  bitsB = NumberToBit(valueB)
  
  bitsA = BitOR(bitsA, bitsB)
  PushIntStack BitToNumber(bitsA)
End Sub

Private Sub DNABitwiseXOR()
  Dim valueA As Long
  Dim valueB As Long
  Dim bitsA As DoubleWord
  Dim bitsB As DoubleWord
  
  valueB = PopIntStack
  valueA = PopIntStack
  
  bitsA = NumberToBit(valueA)
  bitsB = NumberToBit(valueB)
  
  bitsA = BitXOR(bitsA, bitsB)
  PushIntStack BitToNumber(bitsA)
End Sub

Private Sub DNABitwiseINC()
  Dim value As Long
  Dim bits As DoubleWord
  
  value = PopIntStack
  bits = NumberToBit(value)
  IncBits bits
  PushIntStack BitToNumber(bits)
End Sub

Private Sub DNABitwiseDEC()
  Dim value As Long
  Dim bits As DoubleWord
  
  value = PopIntStack
  bits = NumberToBit(value)
  DecBits bits
  PushIntStack BitToNumber(bits)
End Sub

Private Sub DNABitwiseShiftLeft()
  Dim value As Long
  Dim bits As DoubleWord
  
  value = PopIntStack
  bits = NumberToBit(value)
  BitShiftLeft bits
  PushIntStack BitToNumber(bits)
End Sub

Private Sub DNABitwiseShiftRight()
  Dim value As Long
  Dim bits As DoubleWord
  
  value = PopIntStack
  bits = NumberToBit(value)
  BitShiftRight bits
  PushIntStack BitToNumber(bits)
End Sub

'''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''

Private Sub ExecuteConditions(n As Integer)
  rob(currbot).nrg = rob(currbot).nrg - SimOpts.Costs(CONDCOST)
  
  Select Case n
    Case 1 '<
      min
    Case 2 '>
      magg
    Case 3 '=
      equa
    Case 4 ' <>, !=
      diff
    Case 5 ' %=
      cequa
    Case 6 '!%=
      cdiff
    Case 7 '~=
      customcequa
    Case 8 '!~=
      customcdiff
    Case 9  '>=
      maggequal
    Case 10 '<=
      minequal
  End Select
End Sub

Private Function min() As Boolean
  PushBoolStack (PopIntStack > PopIntStack)
End Function

Private Function magg() As Boolean
  PushBoolStack (PopIntStack < PopIntStack)
End Function

Private Function equa() As Boolean
  PushBoolStack (PopIntStack = PopIntStack)
End Function

Private Function diff() As Boolean
  PushBoolStack (PopIntStack <> PopIntStack)
End Function

Private Function cequa() As Boolean
  Dim A As Single
  Dim b As Single
  Dim c As Single
  b = PopIntStack
  A = PopIntStack
  c = A / 10
  PushBoolStack ((A - c <= b) And (A + c >= b))
End Function

Private Function cdiff() As Boolean
  Dim A As Single
  Dim b As Single
  Dim c As Single
  b = PopIntStack
  A = PopIntStack
  c = A / 10
  PushBoolStack (Not ((A + c >= b) And (A - c <= b)))
End Function
Private Function customcequa() As Boolean
'usage: 10 20 30 ~= are 10 and 20 within 30 percent of each other?
  Dim A As Long
  Dim b As Long
  Dim c As Single
  Dim d As Long
  
  d = PopIntStack
  b = PopIntStack
  A = PopIntStack
  c = A / 100 * d
  PushBoolStack ((A - c <= b) And (A + c >= b))
End Function

Private Function customcdiff() As Boolean
  Dim A As Long
  Dim b As Long
  Dim c As Single
  Dim d As Long
    
  d = PopIntStack
  b = PopIntStack
  A = PopIntStack
  c = A / 100 * d
  If Abs(c) > 2000000000 Then c = Sgn(c) * 2000000000
  PushBoolStack (Not ((A + c >= b) And (A - c <= b)))
End Function

Private Function minequal() As Boolean
  PushBoolStack (PopIntStack >= PopIntStack)
End Function

Private Function maggequal() As Boolean
  PushBoolStack (PopIntStack <= PopIntStack)
End Function

'''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''

Private Sub ExecuteLogic(n As Integer)
  Dim A As Integer, b As Integer
  
  b = PopBoolStack
  
  If b <> 5 Then
    Select Case n
      Case 1 'and
        A = PopBoolStack
        If A <> 5 Then
          PushBoolStack A And b
        Else
          PushBoolStack b
        End If
      Case 2 'or
        A = PopBoolStack
        If A <> 5 Then
          PushBoolStack A Or b
        Else
          PushBoolStack b
        End If
      Case 3 'xor
        A = PopBoolStack
        If A <> 5 Then
          PushBoolStack A Xor b
        Else
          PushBoolStack b
        End If
      Case 4 'not
        PushBoolStack Not b
    End Select
  End If
End Sub

'''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''

Private Sub ExecuteStores(n As Integer)
  Select Case n
    Case 1 'store
      DNAstore
      rob(currbot).nrg = rob(currbot).nrg - SimOpts.Costs(COSTSTORE)
    Case 2 'inc
      DNAinc
      rob(currbot).nrg = rob(currbot).nrg - SimOpts.Costs(COSTSTORE) / 10
    Case 3 'dec
      DNAdec
      rob(currbot).nrg = rob(currbot).nrg - SimOpts.Costs(COSTSTORE) / 10
    Case 4 '+=
    Case 5 '-=
    Case 6 '*=
    Case 7 '/=
  End Select
End Sub

Private Sub DNAstore()
  Dim b As Long
  b = PopIntStack
  If b > 0 And b <= MaxMem Then
    rob(currbot).mem(b) = PopIntStack Mod 32000
  End If
End Sub

Private Sub DNAinc()
  Dim A As Long, b As Long
  A = PopIntStack
  
  If A >= 1 And A <= 1000 Then
    b = (rob(currbot).mem(A) + 1) Mod 32000
    rob(currbot).mem(A) = b
  End If
End Sub

Private Sub DNAdec()
  Dim A As Long, b As Long
  A = PopIntStack
  
  If A >= 1 And A <= 1000 Then
    b = (rob(currbot).mem(A) - 1) Mod 32000
    rob(currbot).mem(A) = b
  End If
End Sub

'''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''
Private Function ExecuteFlowCommands(n As Integer) As Boolean
'returns true if a stop command was found (start, stop, or else)
'returns false if cond was found
  ExecuteFlowCommands = False
  Select Case n
    Case 1 'cond
      CurrentFlow = COND
      Exit Function
    Case 2, 3, 4 'assume a stop command, or it really is a stop command
      'this is supposed to come before case 2 and 3, since these commands
      'must be executed before start and else have a chance to go
      ExecuteFlowCommands = True
      If CurrentFlow = COND Then CurrentCondFlag = AddupCond
      CurrentFlow = CLEAR
      Select Case n
        Case 2 'start
          If CurrentCondFlag = NEXTBODY Then CurrentFlow = BODY
          currgene = currgene + 1
        Case 3 'else
          If CurrentCondFlag = NEXTELSE Then CurrentFlow = ELSEBODY
          currgene = currgene + 1
      End Select
  End Select
End Function

Private Function AddupCond() As Boolean
  'AND together all conditions on the boolstack
  Dim A As Integer
  
  AddupCond = True
  
  A = PopBoolStack
  While A <> 5
    AddupCond = AddupCond And A
    A = PopBoolStack
  Wend
End Function

'''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''

'
'   L O A D I N G   A N D   P A R S I N G
'

' root of the dna execution part
' takes each robot and passes it to the interpreter
' with some variations for console debug and genes activation
Public Sub ExecRobs()
  Dim t As Integer
  For t = 1 To MaxRobs
    If rob(t).Exist And Not rob(t).Wall And Not rob(t).Corpse Then
      ExecuteDNA t
    'rob(t).pntr = 1
    'If Not (rob(t).console Is Nothing) Then
    '  rob(t).console.textout ""
    '  rob(t).console.textout "robot genes execution: - =not executed"
    '  eseguidebug t
    'Else
    '  If t = robfocus Then
    '    If ActivForm.Visible Then
    '      exechighlight t
    '    Else
    '      eseguirob2 t
    '    End If
    '  Else
    '    eseguirob2 t
    '  End If
    'End If
    End If
  Next t
End Sub
